package ru.dbotthepony.kstarbound.defs.parallax

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.io.json.builder.BuilderAdapter

class ParallaxPrototype {
	var verticalOrigin = 0.0

	var layers = Array(0) { ParallaxPrototypeLayer() }

	companion object {
		val ADAPTER = BuilderAdapter(
			::ParallaxPrototype,
			ParallaxPrototype::verticalOrigin,
			ParallaxPrototype::layers,
		)

		fun registerGson(gsonBuilder: GsonBuilder) {
			gsonBuilder.registerTypeAdapter(ParallaxPrototype::class.java, ADAPTER)
			gsonBuilder.registerTypeAdapter(ParallaxPrototypeLayer::class.java, ParallaxPrototypeLayer.ADAPTER)
			gsonBuilder.registerTypeAdapter(
				ParallaxPrototypeLayer.Parallax::class.java,
				ParallaxPrototypeLayer.LAYER_PARALLAX_ADAPTER
			)
		}
	}
}